"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Addresses = void 0;
const tslib_1 = require("tslib");
const core_1 = require("@mikro-orm/core");
const _1 = require(".");
let Addresses = class Addresses {
    id;
    city;
    state;
    country;
    arrayField;
    createdAt = new Date();
    updatedAt = new Date();
    user;
};
exports.Addresses = Addresses;
tslib_1.__decorate([
    (0, core_1.PrimaryKey)({
        autoincrement: true,
    }),
    tslib_1.__metadata("design:type", Number)
], Addresses.prototype, "id", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        columnType: 'varchar',
        length: 70,
        nullable: true,
    }),
    tslib_1.__metadata("design:type", String)
], Addresses.prototype, "city", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        columnType: 'varchar',
        length: 70,
        nullable: true,
    }),
    tslib_1.__metadata("design:type", String)
], Addresses.prototype, "state", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        columnType: 'varchar',
        length: 68,
        nullable: true,
    }),
    tslib_1.__metadata("design:type", String)
], Addresses.prototype, "country", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        name: 'array_field',
        type: core_1.ArrayType,
        columnType: 'varchar[]',
        nullable: true,
    }),
    tslib_1.__metadata("design:type", Array)
], Addresses.prototype, "arrayField", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        length: 0,
        name: 'created_at',
        nullable: true,
        defaultRaw: 'CURRENT_TIMESTAMP(0)',
        columnType: 'timestamp(0) without time zone',
    }),
    tslib_1.__metadata("design:type", Date)
], Addresses.prototype, "createdAt", void 0);
tslib_1.__decorate([
    (0, core_1.Property)({
        length: 0,
        onUpdate: () => new Date(),
        name: 'updated_at',
        nullable: true,
        columnType: 'timestamp(0) without time zone',
        defaultRaw: 'CURRENT_TIMESTAMP(0)',
    }),
    tslib_1.__metadata("design:type", Date)
], Addresses.prototype, "updatedAt", void 0);
tslib_1.__decorate([
    (0, core_1.OneToOne)(() => _1.Users, (item) => item.addresses),
    tslib_1.__metadata("design:type", Object)
], Addresses.prototype, "user", void 0);
exports.Addresses = Addresses = tslib_1.__decorate([
    (0, core_1.Entity)({
        tableName: 'addresses',
    })
], Addresses);
//# sourceMappingURL=addresses.js.map