import { EntityRelation } from '../../../../utils/nestjs-shared';
import { ObjectLiteral } from '../../../../types';
import { PostRelationshipData } from '../../../mixin/zod';
import { MicroOrmService } from '../../service';
export declare function postRelationship<E extends ObjectLiteral, Rel extends EntityRelation<E>>(this: MicroOrmService<E>, id: number | string, rel: Rel, input: PostRelationshipData): Promise<E>;
