"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodIncludeInputQuery = zodIncludeInputQuery;
const zod_1 = require("zod");
const nestjs_shared_1 = require("../../../../utils/nestjs-shared");
function zodIncludeInputQuery() {
    return zod_1.z
        .string()
        .optional()
        .transform((data) => {
        if (!data || !(0, nestjs_shared_1.isString)(data))
            return null;
        return data
            .split(',')
            .map((i) => i.trim())
            .filter((i) => !!i);
    });
}
//# sourceMappingURL=include.js.map