import { ResourceObject } from '../../../../utils/nestjs-shared';
import { ObjectLiteral } from '../../../../types';
import { QueryOne } from '../../../mixin/zod';
import { TypeOrmService } from '../../service';
export declare function getOne<E extends ObjectLiteral>(this: TypeOrmService<E>, id: number | string, query: QueryOne<E>): Promise<ResourceObject<E>>;
