import { DynamicModule } from '@nestjs/common';
import { TypeOrmDefaultOptions, TypeOrmOptions, MicroOrmOptions } from './types';
import type { TypeOrmJsonApiModule, MicroOrmJsonApiModule } from './modules';
export declare class JsonApiModule {
    static forRoot(module: typeof TypeOrmJsonApiModule, options: TypeOrmOptions): DynamicModule;
    static forRoot(module: typeof MicroOrmJsonApiModule, options: MicroOrmOptions): DynamicModule;
    /**
     * @deprecated This type of method is deprecated and may be removed in future versions.
     * Consider using newer alternatives or updated patterns for module registration.
     */
    static forRoot(options: TypeOrmDefaultOptions): DynamicModule;
}
