import { ObjectLiteral } from '../../../../types';
import { MicroOrmService } from '../../service';
import { Query } from '../../../mixin/zod';
export declare function getAll<E extends ObjectLiteral>(this: MicroOrmService<E>, query: Query<E>): Promise<{
    totalItems: number;
    items: E[];
}>;
