import { PipeTransform } from '@nestjs/common';
import { Query, InputQuery } from '../../zod';
import { ObjectLiteral } from '../../../../types';
export declare class QueryPipe<E extends ObjectLiteral> implements PipeTransform<InputQuery<E>, Query<E>> {
    private zodQuerySchema;
    transform(value: InputQuery<E>): Query<E>;
}
