import { z } from 'zod';
export declare function zodType<T extends string>(type: T): z.ZodLiteral<T>;
export type ZodType<T extends string> = ReturnType<typeof zodType<T>>;
export type Type<T extends string> = z.infer<ZodType<T>>;
