import { ResourceObject } from '../../../../utils/nestjs-shared';
import { ObjectLiteral } from '../../../../types';
import { Query } from '../../../mixin/zod';
import { TypeOrmService } from '../../service';
export declare function getAll<E extends ObjectLiteral>(this: TypeOrmService<E>, query: Query<E>): Promise<ResourceObject<E, 'array'>>;
