import { EntityRelation, ResourceObjectRelationships } from '../../../../utils/nestjs-shared';
import { TypeOrmService } from '../../service';
import { ObjectLiteral } from '../../../../types';
export declare function getRelationship<E extends ObjectLiteral, Rel extends EntityRelation<E>>(this: TypeOrmService<E>, id: number | string, rel: Rel): Promise<ResourceObjectRelationships<E, Rel>>;
