import { EntityRelation, ResourceObjectRelationships } from '../../../../utils/nestjs-shared';
import { ObjectLiteral } from '../../../../types';
import { PatchRelationshipData } from '../../../mixin/zod';
import { TypeOrmService } from '../../service';
export declare function patchRelationship<E extends ObjectLiteral, Rel extends EntityRelation<E>>(this: TypeOrmService<E>, id: number | string, rel: Rel, input: PatchRelationshipData): Promise<ResourceObjectRelationships<E, Rel>>;
