import { EntityRelation, ResourceObjectRelationships } from '../../../../utils/nestjs-shared';
import { ObjectLiteral } from '../../../../types';
import { PostRelationshipData } from '../../../mixin/zod';
import { TypeOrmService } from '../../service';
export declare function postRelationship<E extends ObjectLiteral, Rel extends EntityRelation<E>>(this: TypeOrmService<E>, id: number | string, rel: Rel, input: PostRelationshipData): Promise<ResourceObjectRelationships<E, Rel>>;
