import { DynamicModule } from '@nestjs/common';
import { AnyEntity, EntityName, MicroOrmOptions, ResultModuleOptions, TypeOrmOptions } from '../types';
import { Type } from '@nestjs/common/interfaces';
export declare function prepareConfig(moduleOptions: TypeOrmOptions | MicroOrmOptions, type: 'typeOrm' | 'microOrm'): Omit<ResultModuleOptions, 'type'>;
export declare function createMixinModule(entity: EntityName<AnyEntity>, resultOption: ResultModuleOptions, commonOrmModule: DynamicModule): DynamicModule;
export declare function createAtomicModule(options: ResultModuleOptions, entitiesMixinModules: DynamicModule[], commonOrmModule: DynamicModule): DynamicModule[];
export declare function entityForClass<T = any>(type: Type<T>): EntityName<AnyEntity>;
